-- $Id: exbugs.ts,v 1.22 1999/04/26 cap Exp $
-- Test Suite: ex bugs (potentially reentrant)

Alias TSL := $cocoa/ts/ts_lib;
TSL.Initialize();

-------------------------------
-- EXBUG 01 : GBasis(Ideal(x,0))
Test := Record[Id = 1,Descr = 'GBasis(Ideal(x,0))'];

Test.Input :='
Use Q[x];
GBasis(Ideal(x,0));
';
Test.ExpectedOutput := 
'[x]
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 02 : MAT^(-1)

Test := Record[Id = 2,Descr = 'MAT^(-1)'];

Test.Input :='
Use Q[x];
N:=Mat([[1,2],[3,4]]);
N^(-1);
';
Test.ExpectedOutput := 
'Mat[
  [-2, 1],
  [3/2, -1/2]
]
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 03 : L := 1..5; Vector(x,y)/L[1];

Test := Record[Id = 3,Descr = 'L := 1..5; Vector(x,y)/L[1];'];

Test.Input :='
Use Q[xy];
L := 1..5;
Vector(x,y)/L[1];
';
Test.ExpectedOutput := 
'Vector(x, y)
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 04 : NF(x,[x])

Test := Record[Id = 4,Descr = 'NF(x,[x])'];

Test.Input :='
Use Q[x];
NR(x,[x]);
';

Test.ExpectedOutput := 
'0
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 05 : Return

Test := Record[Id = 5,Descr = 'Return'];

Test.Input :='
Define Larger(A,B)
  If A > B Then Return A; End;
  Return B;
End;
Larger(1,2);
Larger(2,1);

Define Larger2(A,B)
  If A > B Then Return; End;
  PrintLn "Second is larger";
End;
Larger2(1,2);
Larger2(2,1);
';
Test.ExpectedOutput :=
'2
-------------------------------
2
-------------------------------
Second is larger

-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 06 : Image of constant Poly

Test := Record[Id = 6,Descr = 'Image of constant Poly'];

Test.Input :='
Use T ::= Q[txyz];
Subst(x-x+1,x,1);
';
Test.ExpectedOutput :=
'1
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 07 : HDriven does not work

Test := Record[Id = 7,Descr = 'HDriven does not work'];

Test.Input :="
Use S ::= Z/(32003)[gabcd],Lex;
I := Ideal(a + b + c + d, ab+bc+cd+da,abc+bcd+cda+dab,abcd-g^4);
PS:=Poincare(S/I);
J := Ideal(a + b + c + d, ab+bc+cd+da,abc+bcd+cda+dab,abcd-g^4);
J.PSeries:=PS;
E:=GBasis(J);
If PKG.GB.LastTotSteps<> 7 Then
  Print 'HDRIVEN ERROR'
Else
 Print 'HDRIVEN OK'
End;
";

Test.ExpectedOutput :=
'HDRIVEN OK
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 08 : HDriven Elim does not work

Test := Record[Id = 8,Descr = 'HDriven Elim does not work'];

Test.Input :="
Use S ::= Z/(2)[g,abcdef],Lex;
I := Ideal(a + b,ab + bc,abc + bcd,abcd + bcde,
abcde + bcdef + cdefa + defab + efabc + fabcd ,
g^6 + abcdef);
P:=Poincare(S/I);
I.PSeries:=P;
E:=Elim([a,b,c],I);
If PKG.GB.LastTotSteps<> 21 Then
  Print 'Elim HDRIVEN ERROR'
Else
 Print 'Elim HDRIVEN OK'
End;
";

Test.ExpectedOutput :=
'Elim HDRIVEN OK
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 09 : Resolution after Equality Test

Test := Record[Id = 9,Descr = 'Resolution after Equality Test'];

Test.Input :="
Use S::=Q[x];
I:=Ideal(x);
J:=Ideal(x);
I=J;
Res(I);
";

Test.ExpectedOutput :=
'TRUE
-------------------------------
0 --> S(-1)
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 10 : GMP 2.0.2 bug on add and sub
--
-- if it does not work then try to apply John's patch: 
-- copy files patch_add.c to mpq/add.c and patch_sub.c to mpq/sub.c

Test := Record[Id = 10,Descr = 'GMP 2.0.2 bug on add and sub'];

Test.Input :="
Use Q[txyz];
F:=Product(Indets());
G:=(F^10-1)/(F-1);
Subst(G,[[x,1/2],[y,1/3],[z,1/5],[t,1/7]]);
";

Test.ExpectedOutput :=
'798080429578995215311/794280046581000000000
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 11 : LC(1)

Test := Record[Id = 11,Descr = 'LC must return a coeff of the current ring'];

Test.Input :="
S1 ::= Q[x];
S2 ::= Z/(5)[x];
S1 :: Type(LC(1));
S2 :: Type(LC(1));
";

Test.ExpectedOutput :=
'RAT
-------------------------------
ZMOD
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 12 : Res after Syz of Ideal

Test := Record[Id = 12,Descr = 'Res after Syz of Ideal'];

Test.Input := '
Use S ::= Q[xyz];
I := Ideal(x^2,y^2,xy+yz);
X := SyzOfGens(I);
Res(I);
';

Test.ExpectedOutput :=
'0 --> S(-5) --> S(-3)(+)S^2(-4) --> S^3(-2)
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 13 : Typo in the definition of a ring

Test := Record[Id = 13,Descr = 'Typo in the definition of a ring'];

Test.Input := '
Use S ::= Q[abc];
S :: Q[abc];
Use R;
Destroy S;
S :: Q[abc];
';

Test.ExpectedOutput :=
'ERROR: Cannot cast to INT (non constant poly)
CONTEXT: S :: Q[a * b * c]
-------------------------------
ERROR: Undefined ring-environment S
CONTEXT: S :: Q[a * b * c]
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 14 : SyzMinGens after Syz and viceversa

Test := Record[Id = 14,Descr = 'SyzMinGens after Syz and viceversa'];

Test.Input := '
Use S ::= Q[xy];
I := Ideal(x,y,x+y);
SyzOfGens(I);
SyzMinGens(I);

Use S ::= Q[xy];
I := Ideal(x,y,x+y);
SyzMinGens(I);
SyzOfGens(I);
';

Test.ExpectedOutput :=
'Module(Shifts([x, y, x]), [1, 1, -1], [y, -x, 0])
-------------------------------
Module(Shifts([x, y]), [y, -x - y])
-------------------------------
Module(Shifts([x, y]), [y, -x - y])
-------------------------------
Module(Shifts([x, y, x]), [1, 1, -1], [y, -x, 0])
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 15 : CAST from POLY or INT to RATFUN

Test := Record[Id = 15,Descr = 'CAST from POLY or INT to RATFUN'];

Test.Input := '
Use S ::= Q[x];
Cast(3,RATFUN);
Cast(x,RATFUN);
';

Test.ExpectedOutput :=
'3
-------------------------------
x
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 16 : Indeterminate doubly defined

Test := Record[Id = 16,Descr = 'Indeterminate doubly defined'];

Test.Input := '
Use S ::= Q[x,y,x,z];
Use S ::= Q[x[1..5],x[2..8]];
';

Test.ExpectedOutput :=
'ERROR: Indeterminate already defined x
CONTEXT: Use S ::= Q[x,y,x,z]
-------------------------------
ERROR: Indeterminate already defined x
CONTEXT: Use S ::= Q[x[1..5],x[2..8]]
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 17 : Bad ring definitions

Test := Record[Id = 17,Descr = 'Bad ring definitions'];

Test.Input := '
Use S::=Q[x[3..1]];
Use S::=Z/(100003)[x];
';

Test.ExpectedOutput :=
'ERROR: Bad range 3..1
CONTEXT: Use S ::= Q[x[3..1]]
-------------------------------
ERROR: Bad characteristic 100003
CONTEXT: Use S ::= Z/(100003)[x]
-------------------------------
';
TSL.RegisterTest(Test);


-------------------------------
-- EXBUG 18 : Miscellanea

Test := Record[Id = 18,Descr = 'Miscellanea'];

Test.Input := '
Cond(III=JJJ,1,2);
Use S ::= Q[x];
x>0;
Abs(x);
Bin(2,x);
IsEven(x);
IsEven(3/5);
IsOdd(x);
M:=Mat([[1]]);
Minors(2,M);
Use S ::= Z/(101)[x];
I:=Ideal(x);
HP.PSeries(1,0);
Use Z/(2^31-1);
Use S ::= Q[xy];
Set FullRed;
NF(x+y,Ideal(y));
Unset FullRed;
NF(x+y,Ideal(y));

Use Q[abcdef];
B := 230498234098234098234098234098234;
M := Mat[
   [ 0, a/b, bB, c ],
   [ -a/b, 0, d, e],
   [ -bB, -d, 0, 1/2],
   [ -c, -e, -1/2, 0]
];
Pfaffian(M);
NewMat(2);

Use S ::= Q[xyz];
I := Ideal(x^2-y, x^3-z);
LT(I);
I.GBasis;
';

Test.ExpectedOutput :=
'ERROR: Undefined variable III
CONTEXT: Cond(III = JJJ,1,2)
-------------------------------
ERROR: Cannot compare (expected terms)
CONTEXT: x > 0
-------------------------------
ERROR: Bad parameters x
CONTEXT: Error(ERR.BAD_PARAMS,X)
-------------------------------
ERROR: Bin: Second argument must be a non-negative integer
CONTEXT: Error("Bin: Second argument must be a non-negative integer")
-------------------------------
ERROR: Bad parameters x
CONTEXT: Error(ERR.BAD_PARAMS,X)
-------------------------------
ERROR: Bad parameters 3/5
CONTEXT: Error(ERR.BAD_PARAMS, X)
-------------------------------
ERROR: Bad parameters x
CONTEXT: Error(ERR.BAD_PARAMS, X)
-------------------------------
ERROR: Bad parameters
CONTEXT: Minors(2,M)
-------------------------------
(1)
-------------------------------
ERROR: Bad characteristic
CONTEXT: Use CurrentRingEnv ::= Z/(2^31 - 1)
-------------------------------
x
-------------------------------
x + y
-------------------------------
(bcd - 230498234098234098234098234098234b^2e + 1/2a)/b
-------------------------------
ERROR: Bad number of parameters
CONTEXT: NewMat(2)
-------------------------------
Ideal(x^2, xy, y^2)
-------------------------------
[x^2 - y, -xy + z, -y^2 + xz]
-------------------------------
';
TSL.RegisterTest(Test);


-------------------------------
-- EXBUG 19 : DensePoly and Weights

Test := Record[Id = 19,Descr = 'DensePoly and Weights'];

Test.Input := '
Use A::=Q[x], Weights(0);
Use S ::= Q[abc], Weights(1,2,3);
DensePoly(1);
DensePoly(2);
DensePoly(3);
';

Test.ExpectedOutput :=
'ERROR: Principal weights must all be strictly positive
CONTEXT: Use A ::= Q[x],Weights(0)
-------------------------------
a
-------------------------------
a^2 + b
-------------------------------
a^3 + ab + c
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 20 : Parameter must be an indeterminate

Test := Record[Id = 20,Descr = 'Parameter must be an indeterminate'];

Test.Input := '
Use S ::= Q[xy];
IndetName(xx);
IndetIndex(xx);
x^2..y;
Der(x^5,x^2);
Der(x^5y^5,xy);
';

Test.ExpectedOutput :=
'ERROR: Expected indeterminate
CONTEXT: IndetName(x * x)
-------------------------------
ERROR: Expected indeterminate
CONTEXT: IndetIndex(x * x)
-------------------------------
ERROR: Bad parameters
CONTEXT: x^2..y
-------------------------------
ERROR: Expected indeterminate
CONTEXT: Der(x^5,x^2)
-------------------------------
ERROR: Expected indeterminate
CONTEXT: Der(x^5 * y^5,x * y)
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 21 : Presentation of partial resolution

Test := Record[Id = 21,Descr = 'Presentation of partial resolution'];

Test.Input := '
Use S ::= Q[xyz];
I := Ideal(x^2-zy,xy-z^2,xy);
GB.GetRes(I);
X := Res(I);
GB.GetRes(I);
';

Test.ExpectedOutput :=
'0 --> 
-------------------------------
0 --> S^2(-5) --> S^4(-4) --> S^3(-2)
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 22 : Compliments of John and Dave

Test := Record[Id = 22,Descr = 'Compliments of John and Dave'];

Test.Input := '
S ::= Q[ab];
Ring(S);
S ::= Q[ab];
Ring(S);
Ring(S);
';

Test.ExpectedOutput :=
'Q[a,b]
-------------------------------
Q[a,b]
-------------------------------
Q[a,b]
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 23 : Image (Map of Tagged)
Test := Record[Id = 23,Descr = 'Image (Map of Tagged)'];

Test.Input :='
Use T ::= Q[txyz]; 
A := z;
 
Use S ::= Q[xyz], Weights([1,1,2]); 
Image(A, RMap(0,x,y,z));
';
Test.ExpectedOutput := 
'z
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 24 : I := Ideal(x); I.GBasis := [x]; I=I;

Test := Record[Id = 24,Descr = 'I := Ideal(x); I.GBasis := [x]; I=I;'];

Test.Input :='
Use S ::= Q[txyz];
I := Ideal(x);
I.GBasis := [x];
I=I;
';
Test.ExpectedOutput := 
'TRUE
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 25 : Hilbert di artiniani
 
Test := Record[Id = 25,Descr = 'Hilbert(R/I, 2); -- caso artiniano'];
 
Test.Input :='
Use Q[xyzt];
I := Ideal(t^2,x^3,y^4, z^5);
Hilbert(CurrentRing()/I, 2);
';
Test.ExpectedOutput := 
'9
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 26 : Sundry details
 
Test := Record[Id = 26,Descr = 'Sundries'];
 
Test.Input :='
Use Q[xy];
Mat([ [1,2,3], [1,2] ]);
M:=Mat([[1,Poly(0)],[0,1]]);
LinKer(M);  --> SEGV, fixed this_arpoly2arbrat (polys.c)

Use Q[x[0..99999]];                --> SEGV, fixed indet_info_add (indets.c)
Use Q[x[1..15,1..15,1..15,1..15]]; --> SEGV, almost same bug as above
Use Q[x[0..10,0..10,0..10,0..10,0..10]]; --> gave no error, but should have
-- x[9,9,9,9,9]^5;                    --> x[9,9,10,2,1]^5

If Rand(2,1) > 2 Then PrintLn "Random bug"; End;  --> gave division by 0 error, fixed misc.pkg
Rand(1/2,3/2);  --> now gives error, previously did not  (misc.pkg)
Rand(x,y);      --> now gives error, previously did not  (misc.pkg)

Use Z/(25)[x];
Factor(x);      --> now gives error, previously SEGVed  (jintf.c & jintf.h)
Use Q[x];
Factor(0);      --> now gives error, previously did not  (coclib.pkg)

-- This used to claim that A.X#1 did not exist.
-- (fixed cterm_subst_vars, engine.c)
A:=Record[X=999];
For X:=1 To 2 Do PrintLn A.X; End;

Vector(0,0) = Vector(0,0,0);  --> now gives FALSE, previously gave TRUE
                              -- (fixed pv_eq in pvector.c)
Vector(0,0,0) = Vector(0,0);  --> now gives FALSE, previously gave TRUE
';
Test.ExpectedOutput := 
'ERROR: Bad parameters
CONTEXT: Mat([[1, 2, 3], [1, 2]])
-------------------------------
[ ]
-------------------------------
ERROR: Too many indeterminates
CONTEXT: Use CurrentRingEnv ::= Q[x[0..99999]]
-------------------------------
ERROR: Too many indeterminates
CONTEXT: Use CurrentRingEnv ::= Q[x[1..15,1..15,1..15,1..15]]
-------------------------------
ERROR: Too many indeterminates
CONTEXT: Use CurrentRingEnv ::= Q[x[0..10,0..10,0..10,0..10,0..10]]
-------------------------------
ERROR: Bad parameters
CONTEXT: Return(ERR.BAD_PARAMS)
-------------------------------
ERROR: Bad parameters
CONTEXT: Return(ERR.BAD_PARAMS)
-------------------------------
-- WARNING: Coeffs are not in a field
-- GBasis-related computations could fail to terminate or be wrong
-------------------------------

-------------------------------
ERROR: Bad characteristic
CONTEXT: Return($cocoa/builtin.Factor(P))
-------------------------------
ERROR: Factor: argument must be a polynomial
CONTEXT: Error("Factor: argument must be a polynomial")
-------------------------------
999
999

-------------------------------
FALSE
-------------------------------
FALSE
-------------------------------
';
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 27 : Deg, MDeg
 
Test := Record[Id = 27, Descr = 'Deg of Zero'];
 
Test.Input :='
Use Q[xy];
Deg(0);
Deg(Poly(0));
V:=Vector([0,0]);
Deg(V);
MDeg(0);
MDeg(2);
MDeg("ciao");
';
Test.ExpectedOutput := 
'ERROR: Deg(0) is not defined
CONTEXT: Error("Deg(0) is not defined")
-------------------------------
ERROR: Deg(0) is not defined
CONTEXT: Error("Deg(0) is not defined")
-------------------------------
ERROR: Deg(0) is not defined
CONTEXT: Error("Deg(0) is not defined")
-------------------------------
ERROR: MDeg(0) is not defined
CONTEXT: Error("MDeg(0) is not defined")
-------------------------------
0
-------------------------------
ERROR: MDeg: argument must be POLY or VECTOR
CONTEXT: Error("MDeg: argument must be POLY or VECTOR")
-------------------------------
';
  
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 28 : Comp
 
Test := Record[Id = 28, Descr = 'Comp'];
 
Test.Input :='
Comp("ciao", 1);
Comp([1,2,3], 1);
Comp([[1,100],2,3], 1,2);
Comp([Record(A=100),2,3], 1, "A");
Comp("ciao", "x");
Use Q[xy];
Comp(Vector(x,y), 1);
Comp([0, Record(B=Vector(x,y))], 2, "B", 1);
';
Test.ExpectedOutput := 
'c
-------------------------------
1
-------------------------------
100
-------------------------------
100
-------------------------------
ERROR: Comp: argument must be LIST/VECTOR/STRING-INT or RECORD-STRING
CONTEXT: Error("Comp: argument must be LIST/VECTOR/STRING-INT or RECORD-STRING")
-------------------------------
x
-------------------------------
x
-------------------------------
';
  
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 29 : Factor
 
Test := Record[Id = 29, Descr = 'Factor'];
 
Test.Input :='
Use S29 ::= Z/(3)[a];
F1 := a-1;
F2 := 3a;
F3 := a/a;

Use Q[x];
Factor(F1);
Factor(F2);
Factor(F3);
';
Test.ExpectedOutput := 
'[[S29 :: a - 1, 1]]
-------------------------------
ERROR: Cannot factorize 0
CONTEXT: Error("Cannot factorize 0")
-------------------------------
[ ]
-------------------------------
';
  
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 30 : Diff
 
Test := Record[Id = 30, Descr = 'Diff'];
 
Test.Input :='
Use Q[x];
Diff([x], Ideal(x));
';
Test.ExpectedOutput := 
'ERROR: Diff: arguments must be lists
CONTEXT: Error("Diff: arguments must be lists")
-------------------------------
';
  
TSL.RegisterTest(Test);

-------------------------------
-- EXBUG 31 : Colon, Mingens
 
Test := Record[Id = 31, Descr = 'Ambiguity Ideal : Product; MinGens'];
 
Test.Input :='
Use Q[xyz];
Print("-- Ambiguity Ideal : Product"); 
Ideal(x^2):yz;

Print("-- MinGens - Computation in Progress");
I := Ideal([yy - xx - xy , xx - yz - zz]);
MinGens(I);
GBasis(I);
';
Test.ExpectedOutput := 
'-- Ambiguity Ideal : Product
-------------------------------
ERROR: Colon: arguments must be Ideal:Ideal
CONTEXT: Error("Colon: arguments must be Ideal:Ideal")
-------------------------------
-- MinGens - Computation in Progress
-------------------------------
[x^2 - yz - z^2, -xy + y^2 - yz - z^2]
-------------------------------
[x^2 - yz - z^2, -xy + y^2 - yz - z^2, y^3 - 3y^2z - xz^2 - yz^2 + z^3]
-------------------------------
';
  
TSL.RegisterTest(Test);

